<html>
<head>
<title>OgreD3D11Texture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11Texture.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11Texture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11TEXTURE_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11TEXTURE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderTexture_8h.html">OgreRenderTexture.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a><a class="code" href="classOgre_1_1D3D11Texture.html">00036</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038     <span class="keyword">protected</span>:
<a name="l00039"></a>00039         <span class="comment">// needed to store data between prepareImpl and loadImpl</span>
<a name="l00040"></a><a class="code" href="classOgre_1_1D3D11Texture.html#aefbbe5ebaa4e8f60d7f127e629d0115d">00040</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;vector&lt;MemoryDataStreamPtr&gt;::type</a> &gt; <a class="code" href="classOgre_1_1D3D11Texture.html#aefbbe5ebaa4e8f60d7f127e629d0115d">LoadedStreams</a>;
<a name="l00041"></a>00041 
<a name="l00043"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a2d3a93a96d102b10ca553de304f546ea">00043</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp;   <a class="code" href="classOgre_1_1D3D11Texture.html#a2d3a93a96d102b10ca553de304f546ea" title="D3DDevice pointer.">mDevice</a>;    
<a name="l00044"></a>00044 
<a name="l00046"></a>00046         <span class="comment">//LPDIRECT3D11              *mpD3D;</span>
<a name="l00047"></a>00047         <span class="comment">// 1D texture pointer</span>
<a name="l00048"></a><a class="code" href="classOgre_1_1D3D11Texture.html#ac051ed804f302c102b9064134cf4d62c">00048</a>         ID3D11Texture1D *<a class="code" href="classOgre_1_1D3D11Texture.html#ac051ed804f302c102b9064134cf4d62c" title="D3D11 pointer.">mp1DTex</a>;
<a name="l00049"></a>00049         <span class="comment">// 2D texture pointer</span>
<a name="l00050"></a><a class="code" href="classOgre_1_1D3D11Texture.html#ae8221e368b215db47051a72c7336bee5">00050</a>         ID3D11Texture2D *<a class="code" href="classOgre_1_1D3D11Texture.html#ae8221e368b215db47051a72c7336bee5">mp2DTex</a>;
<a name="l00052"></a><a class="code" href="classOgre_1_1D3D11Texture.html#ace7b58744508d681bf4800649f399a8c">00052</a>         ID3D11Texture3D *<a class="code" href="classOgre_1_1D3D11Texture.html#ace7b58744508d681bf4800649f399a8c" title="cubic texture pointer">mp3DTex</a>;   
<a name="l00054"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a6d933a50f7327a05304cfb72400c5b37">00054</a>         ID3D11Resource  *<a class="code" href="classOgre_1_1D3D11Texture.html#a6d933a50f7327a05304cfb72400c5b37" title="actual texture pointer">mpTex</a>;     
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a3677ac8fca7c31561babdee41abbf56d">00056</a>         ID3D11ShaderResourceView* <a class="code" href="classOgre_1_1D3D11Texture.html#a3677ac8fca7c31561babdee41abbf56d">mpShaderResourceView</a>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <span class="comment">// is dynamic</span>
<a name="l00059"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a52a36f3c5e5f9fbc6b8c2f8409eecf67">00059</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a52a36f3c5e5f9fbc6b8c2f8409eecf67">mIsDynamic</a>; 
<a name="l00060"></a>00060 
<a name="l00062"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a48e7167821030ca9f428b0362328bf94">00062</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>                          <a class="code" href="classOgre_1_1D3D11Texture.html#a48e7167821030ca9f428b0362328bf94" title="cube texture individual face names">mCubeFaceNames</a>[6];
<a name="l00064"></a>00064         <span class="comment">//D3DDEVICE_CREATION_PARAMETERS mDevCreParams;</span>
<a name="l00066"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a5cf0e35cf1f4551363ec7187dfb73dfa">00066</a> <span class="comment"></span>        DXGI_FORMAT                     <a class="code" href="classOgre_1_1D3D11Texture.html#a5cf0e35cf1f4551363ec7187dfb73dfa" title="device creation parameters">mBBPixelFormat</a>;
<a name="l00068"></a>00068         <span class="comment">//D3DPOOL                           mD3DPool;</span>
<a name="l00070"></a>00070 <span class="comment"></span>        <span class="comment">//D3DCAPS9                      mDevCaps;</span>
<a name="l00071"></a>00071         <span class="comment">// Dynamic textures?</span>
<a name="l00072"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a9f5ddff8b885e220f857a9af0025c68d">00072</a>         <span class="keywordtype">bool</span>                            <a class="code" href="classOgre_1_1D3D11Texture.html#a9f5ddff8b885e220f857a9af0025c68d" title="The memory pool being used.">mDynamicTextures</a>;
<a name="l00074"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a40db549d4b815fa135c1cf3b3e5cabd7">00074</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;HardwarePixelBufferSharedPtr&gt;::type</a> <a class="code" href="classOgre_1_1D3D11Texture.html#a40db549d4b815fa135c1cf3b3e5cabd7" title="Vector of pointers to subsurfaces.">SurfaceList</a>;
<a name="l00075"></a><a class="code" href="classOgre_1_1D3D11Texture.html#ab518f4d2c021fa352aa6d9038472ca9f">00075</a>         <a class="code" href="classOgre_1_1D3D11Texture.html#a40db549d4b815fa135c1cf3b3e5cabd7" title="Vector of pointers to subsurfaces.">SurfaceList</a>                     <a class="code" href="classOgre_1_1D3D11Texture.html#ab518f4d2c021fa352aa6d9038472ca9f">mSurfaceList</a>;
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classOgre_1_1D3D11Texture.html#af4969ce6de77fcc779b8d3acec4ae5cf">00077</a>         D3D11_SHADER_RESOURCE_VIEW_DESC <a class="code" href="classOgre_1_1D3D11Texture.html#af4969ce6de77fcc779b8d3acec4ae5cf">mSRVDesc</a>;
<a name="l00079"></a>00079         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a0d9cda90d9bef708c0ebba910d5d5d5a" title="internal method, load a normal texture">_loadTex</a>(<a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> &amp; loadedStreams);
<a name="l00080"></a>00080 
<a name="l00082"></a>00082         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a0a86312767fd92e1108e1a7ac135ca68" title="internal method, create a blank normal 1D Dtexture">_create1DTex</a>();
<a name="l00084"></a>00084         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a97fa1948ed303d7ae2d32fa60a21bee1" title="internal method, create a blank normal 2D texture">_create2DTex</a>();
<a name="l00086"></a>00086         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a034517ead3925c342c104b1e909a5dbd" title="internal method, create a blank cube texture">_create3DTex</a>();
<a name="l00087"></a>00087 
<a name="l00089"></a>00089         DXGI_FORMAT <a class="code" href="classOgre_1_1D3D11Texture.html#ab9b44e522ee2bc6bef4319c61df424a4" title="internal method, return a D3D pixel format for texture creation">_chooseD3DFormat</a>();
<a name="l00090"></a>00090 
<a name="l00092"></a>00092         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#aa192b918a44d12981bee4eef4d892a89">createInternalResources</a>(<span class="keywordtype">void</span>);
<a name="l00094"></a>00094         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a17638d5ed9c5519064288407c09cba7c">createInternalResourcesImpl</a>(<span class="keywordtype">void</span>);
<a name="l00096"></a>00096         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a111d2290afeaa2d788093072f76f09c7">freeInternalResources</a>(<span class="keywordtype">void</span>);
<a name="l00098"></a>00098         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ac6e2bf35b60294742e225023634ed6bc" title="free internal resources">freeInternalResourcesImpl</a>(<span class="keywordtype">void</span>);
<a name="l00100"></a>00100         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a761cc1e491dc1c5eaf1346c8a4eb8654" title="internal method, set Texture class source image protected attributes">_setSrcAttributes</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> height, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> depth, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00102"></a>00102         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a7c7fcce156b492a7a19ed7531d2814b3" title="internal method, set Texture class final texture protected attributes">_setFinalAttributes</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> height, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> depth, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00103"></a>00103 
<a name="l00105"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a0cc886e46f280d6ea34ecfc3ba10670e">00105</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11Texture.html#a0cc886e46f280d6ea34ecfc3ba10670e" title="internal method, the cube map face name for the spec. face index">_getCubeFaceName</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> face)<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">        </span>{ assert(face &lt; 6); <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a48e7167821030ca9f428b0362328bf94" title="cube texture individual face names">mCubeFaceNames</a>[face]; }
<a name="l00107"></a>00107 
<a name="l00110"></a>00110         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ae76cac453cee8d7ceb0f84936ffd7004" title="internal method, create D3D11HardwarePixelBuffers for every face and mipmap level.">_createSurfaceList</a>(<span class="keywordtype">void</span>);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00114"></a>00114         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#aa43c22d7f64c0f47b1c01bc8eddeda73">prepareImpl</a>(<span class="keywordtype">void</span>);
<a name="l00116"></a>00116         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a72f1e010bb461b32b22e48bcbdf5b0cf">unprepareImpl</a>(<span class="keywordtype">void</span>);
<a name="l00118"></a>00118         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ad81f828b393f51fde4ad9f976db62392" title="overriden from Resource">loadImpl</a>();
<a name="l00120"></a>00120         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ad99ce95a4a8a4ea11e399cf131b0b0d0" title="overriden from Resource">postLoadImpl</a>();
<a name="l00121"></a>00121 
<a name="l00126"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a882754b33b61f5c04ef3ad0997c3379e">00126</a>         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> <a class="code" href="classOgre_1_1D3D11Texture.html#a882754b33b61f5c04ef3ad0997c3379e" title="Vector of pointers to streams that were pulled from disk by prepareImpl but have yet to be pushed int...">mLoadedStreams</a>;
<a name="l00127"></a>00127         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> <a class="code" href="classOgre_1_1D3D11Texture.html#a59e332c76c2b0955167334795167084f">_prepareNormTex</a>();
<a name="l00128"></a>00128         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> <a class="code" href="classOgre_1_1D3D11Texture.html#aebec24b7342fde73579499ae3d97447b">_prepareVolumeTex</a>();
<a name="l00129"></a>00129         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> <a class="code" href="classOgre_1_1D3D11Texture.html#a9170deaf1d2b36f43be35660ac417f52">_prepareCubeTex</a>();
<a name="l00130"></a>00130     <span class="keyword">public</span>:
<a name="l00132"></a>00132         <a class="code" href="classOgre_1_1D3D11Texture.html#a11e0c120ae5cce0f1da28812966aee4a" title="constructor">D3D11Texture</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00133"></a>00133             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader, 
<a name="l00134"></a>00134             <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device);
<a name="l00136"></a>00136         <a class="code" href="classOgre_1_1D3D11Texture.html#a0a2b64741a2cdaec8b5f62d80ccf4dfe" title="destructor">~D3D11Texture</a>();
<a name="l00137"></a>00137 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ab3f5c3f62eb8d9e4d7c428c049e62991" title="overriden from Texture">copyToTexture</a>( <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; target );
<a name="l00141"></a>00141         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a71ef0ea4964cb3c2a716de2b1220be51" title="overriden from Texture">loadImage</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp;img );
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00145"></a>00145         <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> <a class="code" href="classOgre_1_1D3D11Texture.html#a62bef664637255d132fc38de10229695">getBuffer</a>(<span class="keywordtype">size_t</span> face, <span class="keywordtype">size_t</span> mipmap);
<a name="l00146"></a>00146 
<a name="l00147"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a323ab3dc288725c57fcf166b13b5cbf3">00147</a>         ID3D11Resource *<a class="code" href="classOgre_1_1D3D11Texture.html#a323ab3dc288725c57fcf166b13b5cbf3">getTextureResource</a>() 
<a name="l00148"></a>00148         { assert(<a class="code" href="classOgre_1_1D3D11Texture.html#a6d933a50f7327a05304cfb72400c5b37" title="actual texture pointer">mpTex</a>); <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a6d933a50f7327a05304cfb72400c5b37" title="actual texture pointer">mpTex</a>; }
<a name="l00150"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a6bec8b930d9233a8b71c77d7d8e9ae13">00150</a>         ID3D11ShaderResourceView *<a class="code" href="classOgre_1_1D3D11Texture.html#a6bec8b930d9233a8b71c77d7d8e9ae13" title="retrieves a pointer to the actual texture">getTexture</a>() 
<a name="l00151"></a>00151         { assert(<a class="code" href="classOgre_1_1D3D11Texture.html#a3677ac8fca7c31561babdee41abbf56d">mpShaderResourceView</a>); <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a3677ac8fca7c31561babdee41abbf56d">mpShaderResourceView</a>; }
<a name="l00152"></a>00152         <span class="comment">/*/// retrieves a pointer to the normal 1D/2D texture</span>
<a name="l00153"></a>00153 <span class="comment">        IDirect3DTexture9 *getNormTexture()</span>
<a name="l00154"></a>00154 <span class="comment">        { assert(mpNormTex); return mpNormTex; }</span>
<a name="l00156"></a>00156 <span class="comment">        IDirect3DCubeTexture9 *getCubeTexture()</span>
<a name="l00157"></a>00157 <span class="comment">        { assert(mpCubeTex); return mpCubeTex; }</span>
<a name="l00158"></a>00158 <span class="comment">        */</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00162"></a>00162         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11Texture.html#a902a4ae8163b660d99668293d749d8e3" title="For dealing with lost devices - release the resource if in the default pool (and return true)...">releaseIfDefaultPool</a>(<span class="keywordtype">void</span>);
<a name="l00164"></a>00164         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ac4648a0f0400ae6f30d382ac57c47e19" title="For dealing with lost devices - recreate the resource if in the default pool (and return true)...">recreateIfDefaultPool</a>(<a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device);
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="classOgre_1_1D3D11Texture.html#ae2c201852391e6bb54c3d83d4fc4c7a9">00166</a>         ID3D11Texture1D * <a class="code" href="classOgre_1_1D3D11Texture.html#ae2c201852391e6bb54c3d83d4fc4c7a9">GetTex1D</a>() {<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ac051ed804f302c102b9064134cf4d62c" title="D3D11 pointer.">mp1DTex</a>;};
<a name="l00167"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a7a05622b98bae504dc5869d48997c642">00167</a>         ID3D11Texture2D * <a class="code" href="classOgre_1_1D3D11Texture.html#a7a05622b98bae504dc5869d48997c642">GetTex2D</a>() {<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ae8221e368b215db47051a72c7336bee5">mp2DTex</a>;};
<a name="l00168"></a><a class="code" href="classOgre_1_1D3D11Texture.html#a872339b6fbacd77934028fc1b016187b">00168</a>         ID3D11Texture3D * <a class="code" href="classOgre_1_1D3D11Texture.html#a872339b6fbacd77934028fc1b016187b">GetTex3D</a>() {<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Texture.html#ace7b58744508d681bf4800649f399a8c" title="cubic texture pointer">mp3DTex</a>;};
<a name="l00169"></a>00169 
<a name="l00170"></a>00170         D3D11_SHADER_RESOURCE_VIEW_DESC <a class="code" href="classOgre_1_1D3D11Texture.html#a2169a3182c0536854614f71d682b278e">getShaderResourceViewDesc</a>() <span class="keyword">const</span>;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     };
<a name="l00174"></a>00174 
<a name="l00181"></a><a class="code" href="classOgre_1_1D3D11TexturePtr.html">00181</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11TexturePtr.">D3D11TexturePtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;D3D11Texture&gt; 
<a name="l00182"></a>00182     {
<a name="l00183"></a>00183     <span class="keyword">public</span>:
<a name="l00184"></a><a class="code" href="classOgre_1_1D3D11TexturePtr.html#aec9e441e96e0f314b6f6783c434dce41">00184</a>         <a class="code" href="classOgre_1_1D3D11TexturePtr.html#aec9e441e96e0f314b6f6783c434dce41">D3D11TexturePtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>&gt;() {}
<a name="l00185"></a><a class="code" href="classOgre_1_1D3D11TexturePtr.html#a712cad834f86e9572578fb815a7ee391">00185</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1D3D11TexturePtr.html#a712cad834f86e9572578fb815a7ee391">D3D11TexturePtr</a>(<a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>&gt;(rep) {}
<a name="l00186"></a><a class="code" href="classOgre_1_1D3D11TexturePtr.html#a9c5baa427bd81955db245eabd65844eb">00186</a>         <a class="code" href="classOgre_1_1D3D11TexturePtr.html#a9c5baa427bd81955db245eabd65844eb">D3D11TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1D3D11TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11TexturePtr.">D3D11TexturePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>&gt;(r) {} 
<a name="l00187"></a><a class="code" href="classOgre_1_1D3D11TexturePtr.html#a0267ddb8be1b1cd1757b119d5503a9f3">00187</a>         <a class="code" href="classOgre_1_1D3D11TexturePtr.html#aec9e441e96e0f314b6f6783c434dce41">D3D11TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>&gt;()
<a name="l00188"></a>00188         {
<a name="l00189"></a>00189             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00190"></a>00190             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00191"></a>00191             {
<a name="l00192"></a>00192                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00193"></a>00193                     <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00194"></a>00194                     <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00195"></a>00195                 <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00196"></a>00196                 <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00197"></a>00197                 {
<a name="l00198"></a>00198                     ++(*pUseCount);
<a name="l00199"></a>00199                 }
<a name="l00200"></a>00200             }
<a name="l00201"></a>00201         }
<a name="l00202"></a>00202 
<a name="l00204"></a><a class="code" href="classOgre_1_1D3D11TexturePtr.html#ae7e60ef32d61fba8f6070f9be76f8895">00204</a>         <a class="code" href="classOgre_1_1D3D11TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11TexturePtr.">D3D11TexturePtr</a>&amp; <a class="code" href="classOgre_1_1D3D11TexturePtr.html#ae7e60ef32d61fba8f6070f9be76f8895" title="Operator used to convert a ResourcePtr to a D3D11TexturePtr.">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00205"></a>00205         {
<a name="l00206"></a>00206             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> == static_cast&lt;D3D11Texture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00207"></a>00207                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00208"></a>00208             <a class="code" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">release</a>();
<a name="l00209"></a>00209             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00210"></a>00210             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00211"></a>00211             {
<a name="l00212"></a>00212                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00213"></a>00213                     <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00214"></a>00214                     <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00215"></a>00215                 <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00216"></a>00216                 <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00217"></a>00217                 {
<a name="l00218"></a>00218                     ++(*pUseCount);
<a name="l00219"></a>00219                 }
<a name="l00220"></a>00220             }
<a name="l00221"></a>00221             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00222"></a>00222         }
<a name="l00224"></a><a class="code" href="classOgre_1_1D3D11TexturePtr.html#a144694c8b833f9d46ffeaeb6ad63d0c7">00224</a>         <a class="code" href="classOgre_1_1D3D11TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11TexturePtr.">D3D11TexturePtr</a>&amp; <a class="code" href="classOgre_1_1D3D11TexturePtr.html#ae7e60ef32d61fba8f6070f9be76f8895" title="Operator used to convert a ResourcePtr to a D3D11TexturePtr.">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; r)
<a name="l00225"></a>00225         {
<a name="l00226"></a>00226             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> == static_cast&lt;D3D11Texture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00227"></a>00227                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00228"></a>00228             <a class="code" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">release</a>();
<a name="l00229"></a>00229             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00230"></a>00230             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00233"></a>00233                     <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00234"></a>00234                     <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00235"></a>00235                 <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00236"></a>00236                 <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00237"></a>00237                 {
<a name="l00238"></a>00238                     ++(*pUseCount);
<a name="l00239"></a>00239                 }
<a name="l00240"></a>00240             }
<a name="l00241"></a>00241             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00242"></a>00242         }
<a name="l00243"></a>00243     };
<a name="l00244"></a>00244 
<a name="l00246"></a><a class="code" href="classOgre_1_1D3D11RenderTexture.html">00246</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11RenderTexture.html" title="RenderTexture implementation for D3D11.">D3D11RenderTexture</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>
<a name="l00247"></a>00247     {
<a name="l00248"></a><a class="code" href="classOgre_1_1D3D11RenderTexture.html#ad5c0f05b8bd3f0269f1285a7c1dbad45">00248</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; <a class="code" href="classOgre_1_1D3D11RenderTexture.html#ad5c0f05b8bd3f0269f1285a7c1dbad45">mDevice</a>;
<a name="l00249"></a><a class="code" href="classOgre_1_1D3D11RenderTexture.html#aebe149c0a587a393332c3779064a8c04">00249</a>         ID3D11RenderTargetView * <a class="code" href="classOgre_1_1D3D11RenderTexture.html#aebe149c0a587a393332c3779064a8c04">mRenderTargetView</a>;
<a name="l00250"></a><a class="code" href="classOgre_1_1D3D11RenderTexture.html#aa66ebda5e3dc5b5ec775ccd5f3ea57a1">00250</a>         ID3D11DepthStencilView * <a class="code" href="classOgre_1_1D3D11RenderTexture.html#aa66ebda5e3dc5b5ec775ccd5f3ea57a1">mDepthStencilView</a>;
<a name="l00251"></a>00251     <span class="keyword">public</span>:
<a name="l00252"></a>00252         <a class="code" href="classOgre_1_1D3D11RenderTexture.html#a2be15b68e23bd3701312292022cda1eb">D3D11RenderTexture</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html">D3D11HardwarePixelBuffer</a> *buffer, <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device );
<a name="l00253"></a>00253         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1D3D11RenderTexture.html#add0fdcad757f28278ff23548409751a3">~D3D11RenderTexture</a>();
<a name="l00254"></a>00254 
<a name="l00255"></a>00255         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11RenderTexture.html#ad028e211ccd347372404245580d92d1e">rebind</a>(<a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html">D3D11HardwarePixelBuffer</a> *buffer);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11RenderTexture.html#a0e7d714194282d87c7e01f36ed0f1ed2" title="Gets a custom (maybe platform-specific) attribute.">getCustomAttribute</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span> *pData );
<a name="l00258"></a>00258 
<a name="l00259"></a><a class="code" href="classOgre_1_1D3D11RenderTexture.html#ad8665d73f7eee362e0d4da2a19eb1493">00259</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11RenderTexture.html#ad8665d73f7eee362e0d4da2a19eb1493">requiresTextureFlipping</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00260"></a>00260     };
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
